10    CLS
20    REM
30    PRINT : PRINT : PRINT:
40    PRINT TAB(15)"================== PRECESS.BAS ======================"
50    PRINT
60    PRINT TAB(22) " ADAPTED  BY CHRIS SPRATT - JUNE, 1985 "
70    REM
80    PRINT  TAB(17) " FROM A PROGRAM IN ASTRONOMY MAGAZINE, AUGUST 1984"
90    PRINT TAB(23) " WRITTEN BY J. P. POOL AND R. L. BERRY"
100   GOSUB 1160
110   CLS: PRINT : PRINT : PRINT : PRINT:
120   REM
130   REM
140   REM
150       PRINT TAB(20) "THIS PROGRAM COMPUTES RIGOROUS PRECESSION"
160       PRINT TAB(20) "FROM A STRING REPRESENTATION OF RA AND DEC"
170       PRINT TAB(20) "AND RETURNS A STRING REPRESENTATION OF THE"
180       PRINT TAB(30) "PRECESSED COORDINATES."
190   REM
200   GOSUB 1160
210       R = .01745329#
220   REM
230   REM  ====== COMPUTE THE CONSTANTS OF PRECESSION ======
240   CLS: PRINT : PRINT:PRINT
250   PRINT TAB(20) :  INPUT  "INITIAL EPOCH";IN
260   PRINT
270   PRINT TAB(20) :  INPUT  "  FINAL EPOCH";FI
280   PRINT :PRINT :PRINT
290       T1 = FI - IN
300       T = T1/100
310       Z0 = ((2305.65*T) + (.302*T*T) + (.018 *T*T*T))
320       Z1 = R*(Z0/3600)
330       Z = (Z0+(.791*T*T))/3600
340       TH = R*(((2003.829#*T)-(.426*T*T)-(.042*T*T*T))/3600)
350   REM
360   REM  ==== INPUT COORDINATES AND PROPER MOTION ====
370   REM
380       PRINT TAB(20)"INITIAL RA:HH MM SS.F"
390       PRINT TAB(20): INPUT "         ";RA$
400       PRINT TAB(20)"INITIAL DC:+DD MM SS"
410       PRINT TAB(20): INPUT "         ";DEC$
420   PRINT TAB(20) :INPUT "PROPER MOTION: <MUra,MUdec>";MURA,MUDC
430   CLS
440       MURA = T1*15 * MURA/3600:MUDC = T1 *MUDC/3600
450       IRA = VAL(MID$(RA$,1,2))
460       IRA = IRA + VAL(MID$(RA$,4,2))/60
470       IRA = IRA + VAL(MID$(RA$,7,4))/3600
480       IRA = 15*IRA
490       IDC = VAL(MID$(DEC$,2,2))
500       IDC = IDC+VAL(MID$(DEC$,5,2))/60
510       IDC = IDC+VAL(MID$(DEC$,8,2))/3600
520       IF MID$(DEC$,1,1) ="-" THEN IDC = -IDC
530       AL0 = R*(IRA+MURA)
540       DL0 = R*(IDC+MUDC)
550   REM
560   REM   =========== PRECESS THE COORDINATES ==========
570   REM
580       A = COS(DL0)*SIN(AL0+Z1)
590       B = (COS(TH)*COS(DL0)*COS(AL0+Z1))-(SIN(TH)*SIN(DL0))
600       C = (SIN(TH)*COS(DL0)*COS(AL0+Z1))+(COS(TH)*SIN(DL0))
610       ALPMZ = ATN(A/B)/R
620       AL = (ALPMZ + Z)/15
630       IF B<0 AND A>0 THEN AL = AL+ 12
640       IF B<0 AND A<0 THEN AL = AL+ 12
650       IF B>0 AND A<0 THEN AL = AL+ 24
660       DL = ATN(C/SQR(1-C*C))/R
670   REM
680   REM  ==== CONVERT DECIMAL RA TO HH MM SS.F STRING ====
690   REM
700       RAH = FIX(AL)
710       RAM = INT(60*(AL-RAH))
720       RAS = INT(3600*(AL-RAH-(RAM/60)))
730       RAF = INT(36000!*(AL-RAH-(RAM/60)-(RAS/3600)))
740       RAH$ = STR$(RAH):RAM$ = STR$(RAM)
750       RAS$ = STR$(RAS) : RAF$ = STR$(RAF)
760       IF RAH<10 THEN MID$(RAH$,1)= "0"
770       IF LEN(RAH$) = 3 THEN RAH$ = MID$(RAH$,2,2)
780       IF RAM<10 THEN MID$(RAM$,1)= "0"
790       IF LEN(RAM$)=2 THEN RAM$=" "+RAM$
800       IF RAS<10 THEN MID$(RAS$,1) = "0"
810       IF LEN(RAS$) = 2 THEN RAS$ = " "+RAS$
820       PRA$ = RAH$+RAM$+RAS$+RAF$
830       MID$(PRA$,9)="."
840   REM
850   REM  ==== CONVERT DECIMAL DEC TO DD MM SS STRING ====
860   REM
870       IF DL<0 THEN SG$="-" ELSE SG$ = "+"
880       DL = ABS(DL)
890       DD = FIX(DL)
900       DM = INT(60*(DL-DD))
910       DS = INT(3600*(DL-DD-(DM/60)))
920       DD$ = STR$(DD) : DM$ = STR$(DM):DS$ = STR$(DS)
930       IF DD<10 THEN MID$(DD$,1) = "0"
940       IF LEN(DD$) = 3 THEN DD$ = MID$(DD$,2,2)
950       IF DM<10 THEN MID$(DM$,1) = "0"
960       IF LEN(DM$)=2 THEN DM$ = " "+DM$
970       IF DS<10 THEN MID$(DS$,1) = "0"
980       IF LEN(DS$) = 2 THEN DS$ = " "+DS$
990       PDC$ = SG$ + DD$ + DM$ + DS$
1000   REM
1010   REM   ==== PRINT EPOCHS AND COORDINATE STRINGS ====
1020   REM
1030   PRINT : PRINT : PRINT : PRINT: PRINT:
1040       PRINT TAB(20)  "EPOCH";IN;RA$+ "  "+DEC$
1050       PRINT : PRINT
1060       PRINT TAB(20)  "EPOCH";FI;PRA$+"  "PDC$
1070       PRINT : PRINT
1080       PRINT TAB(20):INPUT "ANOTHER DATE Y/N" ;A$
1090       IF A$ = "Y" THEN GOTO 1100 ELSE 1150
1100       PRINT :PRINT :PRINT
1110       PRINT TAB(20):
1120       INPUT "ANOTHER? <S>AME OR <N>EW EPOCH" ; ANS$
1130       IF ANS$ = "S" OR ANS$ = "s" THEN GOTO 360
1140       IF ANS$ = "N" OR ANS$ = "n" THEN GOTO 240
1150       END
1160  LOCATE 24,25:PRINT "PRESS ANY KEY TO CONTINUE"
1170       IF INKEY$ = "" THEN 1170
1180       RETURN
