100 'IRA Savings ("IRA")
110 CLS
120 COLOR 0,15 : PRINT "IRA Savings Evaluator" : COLOR 15,0
130 PRINT
140 DEFDBL A-Z
150 DEFINT M-N,Y
160 MONEYFMT$ = "$$##,###,###.##"
170 '     Let user enter data
180 PRINT "Do not enter dollar signs or commas"
190 PRINT
200 INPUT "Annual IRA deposit: ", DEPOSIT
210 INPUT "Annual interest rate (in percent): ", AR
220 INPUT "Annual inflation rate (in percent): ", INFLATION
230 INPUT "Marginal tax rate (in percent): ", TAXRATE
240 INPUT "Penalty for early withdrawal (in percent): ", PENALTY
250 '     Initialize variables
260 TAXRATE = TAXRATE / 100
270 AR = AR / 100
280 INFLATION = INFLATION / 100
290 PENALTY = PENALTY / 100
300 IRABALANCE = 0
310 AUXBALANCE = 0
320 REGBALANCE = 0
330 PRINT
340 PRINT "Press space bar to continue"
350 PRINT
360 '     Compute annual balances
370 FOR YEAR = 1 TO 60
380   WHILE INKEY$ = "" : WEND
390   PRINT
400   IRABALANCE = IRABALANCE * (1 + AR) + DEPOSIT
410   REGBALANCE = REGBALANCE + REGBALANCE * AR * (1 - TAXRATE) + DEPOSIT
420   AUXBALANCE = AUXBALANCE + AUXBALANCE * AR * (1 - TAXRATE) + DEPOSIT *                        TAXRATE
430   'Find total IRA savings
440   TOTALIRA = AUXBALANCE + IRABALANCE * (1 - PENALTY - TAXRATE)
450   INFLATIONADJ = (1 + INFLATION) ^ -YEAR
460   'Print results
470   PRINT "Year: "; YEAR
480   PRINT SPC(10); "IRA Savings"
490   PRINT
500   PRINT "Nominal balance: "; TAB(30);
510   PRINT USING MONEYFMT$; TOTALIRA
520   PRINT "Inflation-adjusted balance: "; TAB(30);
530   PRINT USING MONEYFMT$; TOTALIRA * INFLATIONADJ
540   PRINT
550   PRINT SPC(10); "Savings Without IRA"
560   PRINT
570   PRINT "Nominal balance: "; TAB(30);
580   PRINT USING MONEYFMT$; REGBALANCE
590   PRINT "Inflation-adjusted balance: "; TAB(30);
600   PRINT USING MONEYFMT$; REGBALANCE * INFLATIONADJ
610 NEXT YEAR
620 END
